var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';

var Animator = (_temp = _class = function (_PureComponent) {
  _inherits(Animator, _PureComponent);

  function Animator(props) {
    _classCallCheck(this, Animator);

    var _this = _possibleConstructorReturn(this, _PureComponent.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.getAnimationState(props);
    return _this;
  }

  Animator.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.setState(this.getAnimationState(nextProps));
  };

  Animator.prototype.componentDidMount = function componentDidMount() {
    this.componentDidUpdate();
  };

  Animator.prototype.componentDidUpdate = function componentDidUpdate() {
    var _this2 = this;

    var _props = this.props,
        repeat = _props.repeat,
        animations = _props.animations;
    var _state = this.state,
        animation = _state.animation,
        frame = _state.frame;

    if (animation == null) {
      return;
    }

    var frames = animations[animation].frames;
    var duration = frames[frame].duration;


    var nextFrame = frame < frames.length - 1 ? frame + 1 : repeat ? 0 : -1;
    if (this.pendingTimeout != null) {
      clearTimeout(this.pendingTimeout);
    }

    if (nextFrame < 0) {
      return;
    }

    this.pendingTimeout = setTimeout(function () {
      _this2.pendingTimeout = null;
      _this2.setState(function (prev) {
        return prev.animation === animation && prev.frame === prev.frame ? { frame: nextFrame } : null;
      });
    }, duration);
  };

  Animator.prototype.render = function render() {
    var _props2 = this.props,
        width = _props2.width,
        height = _props2.height,
        spriteUrl = _props2.spriteUrl,
        animations = _props2.animations;
    var _state2 = this.state,
        animation = _state2.animation,
        frame = _state2.frame;

    var x = -1,
        y = -1;
    if (animation) {
      var images = animations[animation].frames[frame].images;

      if (images != null) {
        ;var _images$ = images[0];
        x = _images$[0];
        y = _images$[1];
      }
    }
    return React.createElement('div', {
      style: {
        display: x < 0 || y < 0 ? 'none' : undefined,
        width: width,
        height: height,
        backgroundImage: 'url(' + spriteUrl + ')',
        backgroundPosition: animation != null ? -x + 'px ' + -y + 'px' : null,
        backgroundRepeat: 'no-repeat'
      }
    });
  };

  return Animator;
}(PureComponent), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.state = { animation: null, frame: 0 };

  this.getAnimationState = function (props) {
    var current = _this3.state.animation;
    var animation = props.animation,
        animations = props.animations;


    if (animation != current) {
      return {
        animation: animations.hasOwnProperty(animation) ? animation : null,
        frame: 0
      };
    }
    return null;
  };

  this.pendingTimeout = null;
}, _temp);
export { Animator as default };