function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';

import Agent from './agents/clippy/agent';
import map from './agents/clippy/map.png';

import Animator from './Animator';

var Clippy = function (_PureComponent) {
  _inherits(Clippy, _PureComponent);

  function Clippy() {
    _classCallCheck(this, Clippy);

    return _possibleConstructorReturn(this, _PureComponent.apply(this, arguments));
  }

  Clippy.prototype.render = function render() {
    var _props = this.props,
        animation = _props.animation,
        repeat = _props.repeat,
        rest = _objectWithoutProperties(_props, ['animation', 'repeat']);

    var _Agent$framesize = Agent.framesize,
        width = _Agent$framesize[0],
        height = _Agent$framesize[1],
        animations = Agent.animations;

    return React.createElement(Animator, {
      width: width,
      height: height,
      spriteUrl: map,
      animations: animations,
      animation: animation,
      repeat: repeat
    });
  };

  return Clippy;
}(PureComponent);

export { Clippy as default };